/*
    FxFNav (Fenix File Navigator) is a file manager for GP2x Wiz game console.
    Copyright (C) 2009  Eugene Popov (popov_e_n@mail.ru)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

GLOBAL
// Yes, it is ugly, i know
  Folder_Line top;
END

DECLARE PROCESS Folder(string path, string initial_selection, int waitdeath)
PUBLIC
  string filename="", ext, epath, opts;
  int i, k , w, h, ccc;
  int l = 0;
  int p = 0;
  int aa, a = 0;
  int protected = 0;
  Folder_Line t;
  Manipulator_Line mt;
  
  ALIST files;
  ALIST infos;
  FILE_INFO current_file;
  
  int fcount;
  
  MenuObject menu;
  int dp;
  Preview pobj;
END
END;

DECLARE FUNCTION Read_Folder_To_Menu(string path, int _fld)
PRIVATE
  Folder fld;
  
  FILE_INFO fi;
  MenuLineInfo mi;
  
  
  string epath, filename, ext, opts;
  int i,k;
  MenuStyle mstyle;
END
END;

PROCESS Folder(string path, string initial_selection, int waitdeath)
BEGIN
  say('FOLDER ');
//  let_me_alone();
  dp=0;
  // dispose previous folder
//  WHILE(EXISTS(waitdeath)) FRAME; END;
  
  p = 0;
  a = 0;

//  say("POINT "+(dp++));
  l = len(path);

//  say("POINT "+(dp++));
  IF(substr(path,l-3,3)=="/..")
    path = substr(path,0,l-3);
    //say("cut: "+path);
    i = find(strrev(path),'/');
    IF(i>0)
      path = substr(path,0,l-3-i);
    END;
  END;
//  say("POINT "+(dp++)); //3
  
  IF(substr(path,l-2,2)=="/.")
    path = substr(path,0,l-2);
    //say("cut: "+path);
    i = find(strrev(path),'/');
    IF(i>0)
      path = substr(path,0,l-2-i);
    END;
  END;
//  say("POINT "+(dp++));

  l = len(path);
  IF(path[l-1]!="/") path+="/"; END;
  
   // RELAAAABLEEE :)
  IF( Config.lock_folder_navigation && !ISSUBDIR(Config.lock_folder,path) )
    path = Config.lock_folder;
    initial_selection = '..';
  END;
  
//  say("POINT "+(dp++));
  IF(Config.lock_folder_operations && !ISSUBDIR(Config.lock_folder,path))
    protected = 1;
  END;
  
//  SIGNAL( type Folder_Line, s_kill);
  
  epath = escapeshellarg(path);
//  say("POINT "+(dp++)); //6

  // message
  SAY('top 1 reading...');
  set_text_color(Config.col_normal);
  IF(EXISTS(top)) SIGNAL(top, S_KILL); FRAME; END;
  SAY('top 2 reading...');
  top = Folder_Line(path, _("Reading folder...") , map_clone( 0, Config.map_top));
  top.x = Config.SW/2;
  top.y = Config.TOPPAD/2;
  top.z = 10;
  top.xx   = top.x;
  top.yto  = top.y;
  SAY('nw lists 1');
  FRAME;
//  say("POINT "+(dp++));
  SAY('nw lists 2');
  ALIST_NEW(&files);
  ALIST_NEW(&infos);
  SAY('nw lists 3');
  
  menu = Read_Folder_To_Menu(path , id);
  say("MENU: "  + menu);
  menu.alpha = 0;
  
  say('top');
  IF(EXISTS(top)) SIGNAL(top, S_KILL); /*FRAME;*/ END;
// set headline
  IF(protected)
    set_text_color(Config.col_mp_delete); 
  ELSE
    set_text_color(Config.col_emphas); 
  END;
  
  say('folderline');
  top = Folder_Line(path , path, map_clone(0,Config.map_top));
  top.x = Config.SW/2;
  top.y = Config.TOPPAD/2;
  top.z = 10;
  top.xx   = top.x;
  top.yto  = top.y;

/* Select a file  */
  
  say('iactive');
  menu.iactive = 0; 
  FOR(i=0; i<menu.icnt; i++)
    current_file = files.items[i];
    //say(i+ ' ' + current_file.name +'=='+initial_selection);
    IF(current_file.name == initial_selection) 
      menu.iactive = i; 
      IF(i>3) menu.itop = i - 3; ELSE menu.itop =0; END;
      BREAK; 
    END;
  END;
  menu.command = MENU_CMD_REFRESH;

  menu.alpha = 100;
  say('preview');
  WHILE(menu.command != MENU_CMD_NOP) FRAME 1; END;
  current_file = files.items[menu.selected.key];
  pobj = Preview(menu.selected.value, current_file);
  
// Main control loop
    say('Main LooP');
  LOOP
    current_file = files.items[menu.selected.key];
//  say('LooP');
 //   aa = a;
    State.current_dir = path;
    State.current_file = current_file.name;
    IF ( key(_WIZ_MENU) ) 
      DLG_EXIT(id, &k);
      FRAME;
      IF( k == _WIZ_A)
	SaveState(State, Config.state_file);
	EXIT(0);
	BREAK;
      END;
    END;

    IF ( key(_WIZ_SELECT) )
      IF(EXISTS(Last_Manipulator))
	SIGNAL(Last_Manipulator, S_KILL);
      END;
    END;
    
    IF (key(_CONTROL) || key(_ALT)) 
      WHILE(key(_CONTROL) || key(_ALT)) FRAME; END;
	IF(current_file.f_dir)
	  IF(current_file.name=='..')
	    //up
	    epath = strrev(path);
	    i = find(epath,'/',1);
	    IF(i>0) epath=substr(epath, 1, i-1 ); END;
	    Folder(menu.selected.value, strrev(epath), id);
	  ELSE
	    //down
	    Folder(menu.selected.value, '..', id);
	  END;
	  BREAK;
	END;
	IF(current_file.f_exe)
	  
	  SaveState(State, Config.state_file);
	  CHDIR_AND_EXEC(path, menu.selected.value);
	  
/*	  let_me_alone();
	  FRAME;*/
	  say("Leaving for exec...");
	  EXIT(0);
	  BREAK;
	END;
    END;

    IF ( key(_WIZ_X) ) 
      WHILE( key(_WIZ_X) ) FRAME; END;
      epath = strrev(path);
      i = find(epath,'/',1);
      IF(i>0) epath = substr(epath, 1, i-1 ); END;
      Folder(path+"..", strrev(epath), id);
      BREAK;
    END;
    
    IF ( key(_WIZ_Y)) 
      WHILE( key(_WIZ_Y)) FRAME; END;
      IF(pobj.mode == PREVIEW_MODE_PREVIEW)
	pobj.mode = PREVIEW_MODE_VIEW;
      ELSE
	pobj.mode = PREVIEW_MODE_PREVIEW;
      END;
    END;

    IF (key(_UP))
      i = get_timer() + Config.key_thres;
      WHILE(key(_UP) && get_timer()<i ) FRAME; END;
      menu.command = MENU_CMD_UP;
      //menu feature
      WHILE(menu.command != MENU_CMD_NOP) FRAME 1; END;
      pobj = Preview(menu.selected.value, files.items[menu.selected.key]);
    END;
    
    IF (key(_DOWN)) 
      i = get_timer() + Config.key_thres;
      WHILE(key(_DOWN) && get_timer()<i) FRAME; END;
      menu.command = MENU_CMD_DOWN;
      WHILE(menu.command != MENU_CMD_NOP) FRAME 1; END;
      pobj = Preview(menu.selected.value, files.items[menu.selected.key]);
    END;
    
    IF (key(_LEFT) )
      i = get_timer() + Config.key_thres;
      WHILE( key(_LEFT) && get_timer()<i ) FRAME; END;
      menu.command = MENU_CMD_PGUP;
      WHILE(menu.command != MENU_CMD_NOP) FRAME 1; END;
      pobj = Preview(menu.selected.value, files.items[menu.selected.key]);
    END;
	  
    IF ( key(_RIGHT) ) 
      i = get_timer() + Config.key_thres;
      WHILE( key(_RIGHT) && get_timer()<i ) FRAME; END;
      menu.command = MENU_CMD_PGDOWN;
      WHILE(menu.command != MENU_CMD_NOP) FRAME 1; END;
      pobj = Preview(menu.selected.value, files.items[menu.selected.key]);
    END;
    
    IF ( !protected && key(_WIZ_L) )
      WHILE( key(_WIZ_L) ) FRAME; END;
      IF(EXISTS(Last_Manipulator))
	Last_Manipulator.destination = path;
	Last_Manipulator.doit = id;
	SIGNAL(id,S_SLEEP);
	FRAME;
	IF(!EXISTS(Last_Manipulator))
	  //reread folder if operation complete
	  Folder(path, initial_selection, id);
	  BREAK;
	END;
      END;
    END;
    
    IF ( key(_WIZ_R) )
      WHILE( key(_WIZ_R)) FRAME; END;
	IF(find(current_file.opts,'!')==-1)
	  mt = Manipulator_Line(menu.selected.value, menu.selected.value, protected);
	  IF(EXISTS(mt))
	    mt.x = menu.selected_g.x;
	    mt.y = menu.selected_g.y;
	    mt.z = 200;
	    mt.tox = Config.SW -1 - mt.hh/2;
	    mt.toy = Config.TOPPAD + (Config.SH/2 - Config.TOPPAD);
	    mt.toangle = 90000;
	  END;
	END;
    END;
    
    //IF (a!=aa) Preview(t.full_path, t.ext, t.info); END;
    
    FRAME;
  END;
ONEXIT
  SAY('FOLDER ONEXIT{{');
  SIGNAL(menu, S_KILL);
  WHILE(EXISTS(menu)) FRAME; END;
  /// these pointers are used inside menu
  ALIST_FREE(&files);
  ALIST_FREE(&infos);
  SAY('}}}FOLDER ONEXIT');
END;

FUNCTION Read_Folder_To_Menu(string path, int _fld)
BEGIN
  say("LS "+path);
  epath = escapeshellarg(path);
  
  fld = _fld;
  
  // we DO need async read...
  COMMANDER_EXEC("busybox ls -av1 "+epath+"");
  // skip unneded line
  COMMANDER_GET_RES(&filename);
    
  say("WHILE");
  WHILE( COMMANDER_GET_RES(&filename)>=0 )
    fi = FILE_INFO();
    LS2FILEINFO(path, filename, fi);
    ALIST_ADD(&fld.files, fi);
  END;
  say("END");
  
  FOR(i=0; i<fld.files.count; i++ )
    fi =fld.files.items[i];
    mi = MenuLineInfo();
    mi.caption = fi.name;
    mi.value = path + mi.caption;
    mi.color = Config.col_normal;

    IF(fi.f_dir)
      mi.color = Config.col_file_folder;      
      mi.caption += "/";
      ext = "";
    ELSE
      
      ext = lcase(strrev(fi.name));
      k = find(ext,'.',0);
      IF(k>0)
	ext = strrev(substr(ext,0,k));
      ELSE
	ext = "";
      END;
      
      IF(ext=="gpu" || ext=="gpe") 
	mi.color = Config.col_file_exe;
	fi.f_exe = 1;
      END;      
    END;
    fi.ext = ext;

    IF(fi.name=="." || fi.name=="..")
      fi.opts+="!"; // not movable
    END;
    
    IF(fi.f_link) 
      mi.color = Config.col_file_link;
      fi.opts +="l";
      mi.caption += "@";
    END;
      
    mi.key = i;
    ALIST_ADD(&fld.infos, mi);
  END;
  
  mstyle.color1 = Config.col_normal;
  mstyle.color2 = Config.col_active;
  mstyle.font1  = Config.ttt_font;
  mstyle.font2  = Config.ttt_font_b;
  mstyle.line_height  = Config.font_height+1;
  
  say("MENU");
  k = MenuFromItemInfoList(
    &fld.infos,
    mstyle,
    Config.SW - Config.font_height ,
    Config.SH - Config.TOPPAD ,
    15
    );
  say("END: "+k);
  k.x = 160;
  k.y = Config.TOPPAD + (Config.SH - Config.TOPPAD)/2;
  SAY("END LS");
    
  return k;
END;

