#!/bin/sh

# cange ths paths according to your system
OPENWIZ="/opt/arm-openwiz-linux-gnu"
FENIX_DIR=$(pwd)/Fenix092a

TARGET="truettf.so"

case "$1" in
    wiz) 
	CC="$OPENWIZ/bin/arm-openwiz-linux-gnu-gcc"
	LD="$OPENWIZ/bin/arm-openwiz-linux-gnu-ld"
	CFLAGS="-I$OPENWIZ/include -I$OPENWIZ/include/SDL"
	LFLAGS="-shared -L$OPENWIZ/lib -lSDL_ttf"
	;;
    *) 
	CC="gcc"
	LD="gcc"
	CFLAGS="$(sdl-config --cflags)"
	LFLAGS="-shared $(sdl-config --libs) -lSDL_ttf"
	;;
esac

rm truettf.o
rm $TARGET

$CC -Wall -I$FENIX_DIR/fxc/inc -I$FENIX_DIR/fxi/inc -I$FENIX_DIR/include $CFLAGS -c truettf.c
$LD -o$TARGET truettf.o  $LFLAGS

echo $CC -Wall -I$FENIX_DIR/fxc/inc -I$FENIX_DIR/fxi/inc -I$FENIX_DIR/include $CFLAGS -c truettf.c
echo $LD -o$TARGET truettf.o $LFLAGS
