include "truettf.fh";

Private
    int fontCJK, fontCYR, fd;
    string str;
Begin
    set_mode(320,240,16);

    fontCJK = load_truettf("batang.ttf",20);

    fd  = fopen("strings.utf8",O_READ);
    While(!feof(fd))
      str = fgets(fd);
      set_text_color(rgb(rand(100,255),rand(100,255),rand(100,255)));
      TextFloat( str ,fontCJK ,TT_ENC_UTF8 | TT_ALIGN_H_CENTER | TT_ALIGN_V_MIDDLE);
    End;
    fclose(fd);

    Repeat
	Frame;
    Until(key(_ESC) OR key(_ENTER));

    let_me_alone();

    unload_truettf(fontCJK);

    fontCYR = load_truettf("courier-1251.ttf",20);

    While(key(_ESC) OR key(_ENTER)) Frame; End;

    fd  = fopen("strings.cp1251",O_READ);
    While(!feof(fd))
      str = fgets(fd);
      set_text_color(rgb(rand(100,255),rand(100,255),rand(100,255)));
      TextFloat( str ,fontCYR,TT_ENC_ASCII | TT_ALIGN_H_CENTER | TT_ALIGN_V_MIDDLE);
    End;
    fclose(fd);

    Repeat
	Frame;
    Until(key(_ESC) OR key(_ENTER));

    let_me_alone();

End

Process TextFloat(string text, int font, int opts)
Private
  int dx, dy;
Begin
    x = rand(0,319);
    y = rand(0,239);
    If(rand(0,1)) dx = 1; Else dx=-1; End;
    If(rand(0,1)) dy = 1; Else dy=-1; End;

    graph = write_truettf(0, 0, font, 0, 0, opts | TT_NEW_MAP, text);

    While(True)
    x+=dx;
    y+=dy;

    If(x<0) x=319; end;
    If(y<0) y=239; end;
    If(x>319) x=0; end;
    If(y>239) y=0; end;
        Frame;
    End;

End
